unit CAprovacao;

interface

uses
  CRequisicao;

type
  TAprovacao = class
  public
    class procedure RealizaAprovacao(const Requisicao: TRequisicao;
      const PrimeiraAprovacao: Integer);
end;

implementation

{ TAprovacao }

uses
  CAprovador, CDiretor, CGerente, CSupervisor;

{
  Primeira Aprovacao: Define quem ser o primeiro da cadeia a aprovar a requisio
  0: Supervisor
  1: Gerente
  2: Diretor
}
class procedure TAprovacao.RealizaAprovacao(const Requisicao: TRequisicao;
  const PrimeiraAprovacao: Integer);
var
  Supervisor: TAprovador;
  Gerente: TAprovador;
  Diretor: TAprovador;
begin
  Supervisor := TSupervisor.Create;
  Gerente := TGerente.Create;
  Diretor := TDiretor.Create;

  Supervisor.Sucessor := Gerente;
  Gerente.Sucessor := Diretor;

  case PrimeiraAprovacao of
    0 : Supervisor.Aprovar(Requisicao);
    1 : Gerente.Aprovar(Requisicao);
    2 : Diretor.Aprovar(Requisicao);
  end;
end;

end.
