unit untDados;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Data.DB, Datasnap.DBClient,
  Vcl.ExtCtrls, Vcl.DBCtrls, Vcl.Grids, Vcl.DBGrids, Vcl.StdCtrls;

type
  TForm1 = class(TForm)
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    ClientDataSet1: TClientDataSet;
    DataSource1: TDataSource;
    btnLoadFromFile: TButton;
    OpenDialog1: TOpenDialog;
    btnDelta: TButton;
    DBGrid2: TDBGrid;
    ClientDataSet2: TClientDataSet;
    DataSource2: TDataSource;
    btnSaveToFile: TButton;
    procedure btnLoadFromFileClick(Sender: TObject);
    procedure btnDeltaClick(Sender: TObject);
    procedure btnSaveToFileClick(Sender: TObject);
  private
    { Private declarations }
    FFileName: string;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.btnDeltaClick(Sender: TObject);
begin
  // Se houveram alteraes nos dados
  if ClientDataSet1.ChangeCount > 0 then
  begin
    // Atribui o Delta do Client1 ao Data do Client2
    ClientDataSet2.Data := ClientDataSet1.Delta;
    ClientDataSet2.Active := True;
  end;
end;

procedure TForm1.btnLoadFromFileClick(Sender: TObject);
begin
  ClientDataSet1.Active := False;

  if OpenDialog1.Execute then
  begin
    // Guarda no campo FFileName o caminho complete do arquivo selecionado
    FFileName := OpenDialog1.FileName;

    ClientDataSet1.LoadFromFile(FFileName);
    ClientDataSet1.Active := True;
  end;
end;

procedure TForm1.btnSaveToFileClick(Sender: TObject);
begin
  // Verifica se o campo guarda algum caminho de arquivo
  if FFileName <> '' then
  begin
    // Salva os dados da memria em disco
    ClientDataSet1.SaveToFile(FFileName);
    ShowMessage('Dados salvos em disco!');
  end;
end;

end.
